SystemOrganization addCategory: #Perspectives!
SystemOrganization addCategory: #'Perspectives-Tests'!
SystemOrganization addCategory: #'Perspectives-Visualization'!
SystemOrganization addCategory: #'Perspectives-Signals'!
SystemOrganization addCategory: #'Perspectives-Examples'!

PluggableTextMorphPlus subclass: #PPluggableTextMorphPlus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PPluggableTextMorphPlus methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 14:02'!
textMorphClass
	^PTextMorphForEditView! !

SystemWindow subclass: #PVisualizer
	instanceVariableNames: 'window list stepsPane steps selectedStep disconnectors instanceCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PVisualizer class methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:47'!
open
	^ self new open! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 14:14'!
aboutToEvaluate
	self reset! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 23:33'!
accept: text
	"ignore"! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 1/11/2012 13:48'!
addStep: aStep
	steps addStep: aStep! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 13:52'!
afterEvaluate
	list updateList.
	stepsPane update.! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 13:51'!
beforeEvaluate
	self reset! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 1/9/2012 21:19'!
connectSignals
	disconnectors
		add: (PObject onInstanceCreation: [ :instance | self instanceCreated: instance ])! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/14/2011 14:47'!
createChildren
	| htop hbottom wleft |
	htop := 0.2.
	hbottom := 0.2.
	wleft := 0.3.
	window
		addMorph: self createUpperPane frame: (0@0 corner: 1@htop);
		addMorph: self createList frame: (0@htop corner: wleft@(1-hbottom));
		addMorph: self createPane frame: (wleft@htop corner: 1@(1-hbottom));
		addMorph: self createLowerPane frame: (0@(1-hbottom) corner: 1@1)! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/16/2011 22:55'!
createList
	^ (list := PluggableListMorph
		on: self
		list: #steps
		selected: #selectedStep
		changeSelected: #selectStep:)
			color: Color white;
			yourself
		! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 1/10/2012 21:55'!
createLowerPane
	^ PluggableTextMorphPlus
		on: self
		text: #lowerPaneText
		accept: #accept:! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/29/2011 17:23'!
createPane
	^ stepsPane := (PStepsPane on: steps)
		color: Color white;
		yourself! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 1/7/2012 14:17'!
createUpperPane
	| text |
	text := PPluggableTextMorphPlus
		on: self
		text: #upperPaneText
		accept: #accept:.
	text wantsFrameAdornments: false.
	text styler: (SHTextStylerST80 new view: text; yourself).
	text textMorph editor model: self.
	^ text! !

!PVisualizer methodsFor: 'layout' stamp: 'RL 12/14/2011 14:56'!
createWindow
	window := SystemWindow new.
	window
		model: self;
		setLabel: 'PVisualizer';
		setWindowColor: self defaultColor.
	self
		createChildren! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 1/9/2012 21:19'!
disconnectSignals
	disconnectors do: #disconnect! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:14'!
doItContext
	^ nil! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 23:43'!
doItReceiver
	^ self ! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 23:04'!
finalize
	self disconnectSignal! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:46'!
found: aCompiledMethod for: aPiece
	self addStep: (PFoundStep on: aPiece with: aCompiledMethod)! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 1/10/2012 19:37'!
initialize
	super initialize.
	steps := PStepList new.
	self createWindow.
	instanceCount := 0.
	disconnectors := Set new.
	self connectSignals.! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 1/16/2012 16:44'!
instanceCreated: anInstance
	| instance |
	instanceCount := instanceCount + 1.
	instance := PInstance for: anInstance with: instanceCount.
	self addStep: (PInstanceCreationStep for: instance).
	anInstance methodDispatcher methodLookup
		onLookingUp: [ :selector :perspective | self lookingUp: selector for: instance in: perspective ];
		onSearching: [ :class :perspective | self searching: class in: perspective for: instance ];
		onFound: [ :method |  self found: method for: instance ].! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 1/7/2012 16:43'!
lookingUp: aSelector for: aPiece in: perspective
	self addStep: (PLookUpStep on: aPiece with: aSelector in: perspective)! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 1/10/2012 21:54'!
lowerPaneText
	 ^ ''! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:48'!
open
	"window openInWorldExtent: 800@600"
	window openInWorld! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 16:48'!
reset
	steps reset.
	list updateList.
	stepsPane update.
	instanceCount := 0! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 1/16/2012 16:45'!
searching: aClass in: aPerspective for: instance
	self addStep: (PSearchingStep on: instance for: aClass in: aPerspective)! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 1/11/2012 13:45'!
selectStep: anIndex
	selectedStep := anIndex.
	list updateList.
	"stepsPane selectStep: anIndex"! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:13'!
selectedClass
	^ self class! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/16/2011 22:54'!
selectedStep
	^ selectedStep ifNil: [0]! !

!PVisualizer methodsFor: 'steps' stamp: 'RL 12/29/2011 14:19'!
steps
	^ steps steps! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 02:04'!
upperPaneText
	 ^ '(PerspectiveObject1 new @ TestChildLayer) returnValue.
(PerspectiveObject2 new @ TestLayer) returnValue.'! !

!PVisualizer methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 16:36'!
windowIsClosing
	self disconnectSignals! !

ScrollPane subclass: #PStepsPane
	instanceVariableNames: 'steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PStepsPane class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:27'!
on: aPStepList
	^ self new
		steps: aPStepList;
		yourself! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 16:43'!
paneMorph
	| morph |
	morph := Morph new.
	morph
		layoutPolicy: TableLayout new;
		cellInset: 10;
		layoutInset: 10;
		cellPositioning: #bottomCenter;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	steps instances do: [ :instance | | m |
		m := PInstanceMorph for: instance.
		morph addMorph: m
	].
	^ morph! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:23'!
selectStep: anIndex! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:22'!
steps: stepList
	steps := stepList! !

!PStepsPane methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 15:19'!
update
	self scroller
		removeAllMorphs;
		addMorph: self paneMorph;
		changed.! !

Object subclass: #PDisconnector
	instanceVariableNames: 'disconnectBlock disconnected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Signals'!

!PDisconnector class methodsFor: 'as yet unclassified' stamp: 'RL 1/10/2012 19:37'!
for: aBlock
	^ self new
		disconnectBlock: aBlock;
		yourself! !

!PDisconnector methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2012 21:18'!
disconnect
	disconnected ifTrue: [ ^ self ].
	disconnectBlock value.
	disconnected := true! !

!PDisconnector methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2012 21:18'!
disconnectBlock: aBlock
	disconnectBlock := aBlock! !

!PDisconnector methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2012 21:18'!
initialize
	disconnected := false! !

Object subclass: #PInstance
	instanceVariableNames: 'instance id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PInstance class methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:03'!
for: instance with: id
	^ self new
		instance: instance;
		id: id;
		yourself! !

!PInstance methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 13:34'!
classHierarchy
	| class hierarchy |
	hierarchy := OrderedCollection new.
	class := instance class.
	[ class isNil ] whileFalse: [
		(class inheritsFrom: PObject)
			ifTrue: [hierarchy add: class.
					class := class superclass]
			ifFalse: [ class := nil ]
	].
	^ hierarchy! !

!PInstance methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:02'!
id
	^ id! !

!PInstance methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:02'!
id: anId
	id := anId! !

!PInstance methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:02'!
instance
	^ instance! !

!PInstance methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:02'!
instance: anInstance
	instance := anInstance! !

!PInstance methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:03'!
printOn: aStream
	instance printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: id asString;
		nextPutAll: ')'! !

Object subclass: #PLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

PLayer class
	instanceVariableNames: 'parentLayer'!

PLayer class
	instanceVariableNames: 'parentLayer'!

PLayer subclass: #PAddress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Examples'!

PLayer subclass: #PDefaultLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PDefaultLayer class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 01:15'!
subclass: t instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat 
	self error: 'This layer cannot be subclassed'! !

!PDefaultLayer class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 01:15'!
subclass: t uses: aTraitCompositionOrArray instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat 
	self error: 'This layer cannot be subclassed'! !

PLayer subclass: #PEmployment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Examples'!

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/7/2011 12:09'!
hasParentLayer
	^ parentLayer notNil! !

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
initialParentLayer
	"subclasses should override this and return the initial parent layer to be used upon class creation"
	^ nil! !

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/7/2011 11:56'!
new
	self shouldNotImplement! !

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:54'!
parentLayer
	^ parentLayer ifNil: [ self initialParentLayer ]! !

!PLayer class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:09'!
parentLayer: aLayer
	(aLayer inheritsFrom: PLayer)
		ifTrue: [ parentLayer := aLayer ]
		ifFalse: [ self error: 'parentLayer has to be a subclass of PerspectiveLayer' ]! !

PLayer subclass: #TestChildLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestChildLayer class methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 02:03'!
initialParentLayer
	^ TestLayer! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:51'!
doSomethingWith: aNumber
	^ self proceedWith: 2*aNumber! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:45'!
isTestChildLayer
	^ true! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 22:13'!
method1
	<pragma: #hide>! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:29'!
newMethod
	^ 2! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 18:25'!
returnValue
	^ 15! !

!TestChildLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:55'!
someValue
	^ self proceed * 2! !

PLayer subclass: #TestLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:51'!
doSomethingWith: aNumber
	^ 2 * aNumber! !

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/8/2011 23:44'!
isTestLayer
	^ true! !

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/4/2011 17:19'!
returnValue
	^ 23! !

!TestLayer methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 12:55'!
someValue
	^ 100! !

Object subclass: #PMethod
	instanceVariableNames: 'timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PMethod methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 02:16'!
doesNotUnderstand: aMessage
	"ignore"
	Transcript show: aMessage; cr.
	^ ''! !

!PMethod methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 11:49'!
getSourceFor: selector in: class
	| args stream |
	args := (selector keywords select: [ :k | k endsWith: ':' ]) collectWithIndex: [ :k :i | 'arg', i asString ].
	stream := WriteStream on: ''.
	args isEmpty ifTrue: [stream nextPutAll: selector] ifFalse: [
	args with: selector keywords do: [:arg :word |
		stream nextPutAll: word.
		stream space.
		stream nextPutAll: arg.
		stream space.
	]. stream skip: -1.].
	stream cr; tab.
	stream nextPutAll: '"handled by a perspective message dispatcher"'.
	^ stream contents! !

!PMethod methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 17:50'!
method
	^ self! !

!PMethod methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 17:42'!
methodClass: class
	"ignore"! !

!PMethod methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 14:38'!
run: selector with: arguments in: receiver
	^ receiver methodDispatcher
		send: selector
		withArguments: arguments! !

!PMethod methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 17:42'!
selector: selector
	"ignore"! !

!PMethod methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 20:50'!
timeStamp
	^ timestamp ifNil: [ '' ]! !

!PMethod methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 20:50'!
timeStamp: aTimeStamp
	timestamp := aTimeStamp! !

Object subclass: #PMethodDispatcher
	instanceVariableNames: 'receiver stack methodLookup lookupClassStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PMethodDispatcher class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:44'!
for: receiver
	^ self new
		receiver: receiver;
		yourself! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 15:33'!
cannotProceed
	self error: 'Cannot proceed'
	! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 1/12/2012 20:48'!
currentParentPerspective
	^ self currentPerspective
		ifNotNil: [ :perspective |	perspective parentLayer ].! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 1/16/2012 16:26'!
currentPerspective
	^ stack isEmpty
		ifTrue: [ PDefaultLayer ]
		ifFalse: [ stack top value ]! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 12/29/2011 16:45'!
currentSelector
	^ stack isEmpty
		ifTrue: [ nil ]
		ifFalse: [ stack top key ]! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:28'!
initialize
	super initialize.
	stack := Stack new.
	lookupClassStack := Stack new.! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 1/16/2012 13:31'!
lookupClass
	^ lookupClassStack isEmpty
		ifFalse: [ lookupClassStack top ]
		ifTrue: [ receiver class ]! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:06'!
lookupSelector: aSelector
	^ self
		lookupSelector: aSelector
		in: self currentPerspective
		forClass: self lookupClass! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:23'!
lookupSelector: aSelector in: aPerspective forClass: aClass
	^ self methodLookup
		lookupClass: aClass;
		perspective: aPerspective;
		selector: aSelector;
		lookup! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 20:40'!
makeMessage: selector withArguments: arguments
	^ (Message selector: selector arguments: arguments)
			lookupClass: self lookupClass;
			yourself! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:11'!
methodLookup
	^ methodLookup ifNil: [ methodLookup := PMethodLookup for: self lookupClass ]! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 15:28'!
parent
	^ receiver @ self parentLayer
	! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 15:19'!
parentLayer
	^ (self currentPerspective ifNil: [ ^ nil ]) parentLayer
	! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 12/29/2011 16:44'!
pop
	stack pop! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 1/16/2012 13:29'!
popLookupClass
	lookupClassStack pop! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 1/16/2012 13:23'!
privateSend: aSelector withArguments: arguments from: aPerspective for: aClass
	| result |
	self push: aSelector in: aPerspective.
	result := (self lookupSelector: aSelector in: self currentPerspective forClass: aClass)
		ifNil: [ self sendDoesNotUnderstand: aSelector withArguments: arguments from: aPerspective ]
		ifNotNil: [ :method | receiver withArgs: arguments executeMethod: method ].
	self pop.
	^ result! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 12/29/2011 16:49'!
proceed
	^ self proceedWithArguments: #()
	! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 1/12/2012 20:49'!
proceedWithArguments: arguments
	| perspective |
	self currentSelector = #proceed ifTrue: [ ^ self cannotProceed ].
	perspective := self currentParentPerspective ifNil: [ ^ self cannotProceed ].
	^ self
		send: self currentSelector
		withArguments: arguments
		from: perspective
	
	! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 1/16/2012 13:21'!
push: aSelector in: aPerspective
	stack push: aSelector -> aPerspective! !

!PMethodDispatcher methodsFor: 'stack' stamp: 'RL 1/16/2012 13:28'!
pushLookupClass: aClass
	lookupClassStack push: aClass! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:44'!
receiver
	^ receiver! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:44'!
receiver: anObject
	receiver := anObject! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 1/12/2012 20:42'!
send: aSelector withArguments: arguments
	^ self
		send: aSelector
		withArguments: arguments
		from: self currentPerspective! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 1/16/2012 13:25'!
send: aSelector withArguments: arguments from: aPerspective
	^ self privateSend: aSelector withArguments: arguments from: aPerspective for: self lookupClass! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 1/16/2012 16:23'!
sendDoesNotUnderstand: selector withArguments: arguments from: perspective
	^ (self lookupSelector: #doesNotUnderstand: in: perspective forClass: self lookupClass)
		ifNil: [ receiver doesNotUnderstand: (self makeMessage: selector withArguments: arguments) ]
		ifNotNil: [ :method | receiver withArgs: (Array with: (self makeMessage: selector withArguments: arguments)) executeMethod: method ].! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 1/11/2012 15:41'!
sendMessage: aMessage
	^ self
		send: aMessage selector
		withArguments: aMessage arguments
		in: self currentPerspective! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 1/12/2012 20:41'!
sendMessage: aMessage from: aPerspective
	^ self
		send: aMessage selector
		withArguments: aMessage arguments
		from: aPerspective! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 1/16/2012 13:34'!
superSend
	^ self superSendWithArguments: #()! !

!PMethodDispatcher methodsFor: 'dispatching' stamp: 'RL 1/16/2012 13:34'!
superSendWithArguments: arguments
	| result |
	self pushLookupClass: self lookupClass superclass.
	result := self privateSend: self currentSelector withArguments: arguments from: self currentPerspective for: self lookupClass.
	self popLookupClass.
	^ result! !

!PMethodDispatcher methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 01:06'!
thisLayer
	^ self currentPerspective
	! !

Object subclass: #PMethodLookup
	instanceVariableNames: 'lookupClass perspective selector signalHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PMethodLookup class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:50'!
for: aClass
	^ self new
		lookupClass: aClass;
		yourself! !

!PMethodLookup methodsFor: 'signal-emitting' stamp: 'RL 1/13/2012 14:24'!
found: aCompiledMethod
	Transcript show: (aCompiledMethod ifNil: ['not found'] ifNotNil: ['found']); cr.
	^ signalHandler emit: #found with: aCompiledMethod! !

!PMethodLookup methodsFor: 'signal-emitting' stamp: 'RL 12/29/2011 15:51'!
hiddenMethod
	signalHandler emit: #hiddenMethod! !

!PMethodLookup methodsFor: 'lookup' stamp: 'RL 1/16/2012 16:43'!
inClassHierarchyLookupFor: aPerspective
	| class |
	class := lookupClass.
	[ class isNil ] whileFalse: [
		self searching: class in: aPerspective.
		(class inheritsFrom: PObject) ifFalse: [ ^ aPerspective = PDefaultLayer
				ifFalse: [ nil ]
				ifTrue: [ class lookupSelector: selector ] ].
		(class includesSelector: selector for: aPerspective)
			ifTrue: [ ^ class compiledMethodAt: selector for: aPerspective ].
		class := class superclass
	].
	^ nil! !

!PMethodLookup methodsFor: 'lookup' stamp: 'RL 1/13/2012 12:00'!
inPerspectiveHierarchyLookup
	| p |
	p := perspective.
	[ p isNil ] whileFalse: [
		(self inClassHierarchyLookupFor: p) ifNotNil: [ :method | ^ method ].
		p := p parentLayer
	].
	^ nil! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:02'!
initialize
	super initialize.
	signalHandler := PSignalHandler new! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:52'!
isHidden: aMethod
	^ aMethod
		ifNil: [ false ]
		ifNotNil: [ :method |
			method pragmas
				anySatisfy: [ :pragma | pragma arguments
					anySatisfy: [ :arg | arg = #hide ] ] ]! !

!PMethodLookup methodsFor: 'signal-emitting' stamp: 'RL 1/13/2012 14:23'!
lookingUp: aSelector
	Transcript show: 'lookup: ', aSelector asString, ' ', lookupClass name asString; cr.
	^ signalHandler emit: #lookingUp with: aSelector with: perspective! !

!PMethodLookup methodsFor: 'lookup' stamp: 'RL 1/16/2012 16:29'!
lookup
	| method |
	self lookingUp: selector.
	method := self inPerspectiveHierarchyLookup.
	(self isHidden: method) ifTrue: [ self hiddenMethod. ^ nil ].
	self found: method.
	^ method! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:32'!
lookupClass
	^ lookupClass! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/6/2011 00:32'!
lookupClass: aClass
	lookupClass := aClass! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/16/2011 20:09'!
onFound: aBlock
	^ signalHandler connect: #found to: aBlock! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/29/2011 15:51'!
onHiddenMethod: aBlock
	^ signalHandler connect: #hiddenMethod to: aBlock! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/16/2011 20:10'!
onLookingUp: aBlock
	^ signalHandler connect: #lookingUp to: aBlock! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/16/2011 20:09'!
onSearching: aBlock
	^ signalHandler connect: #searching to: aBlock! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:52'!
perspective
	^ perspective! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 15:52'!
perspective: aPerspective
	perspective := aPerspective! !

!PMethodLookup methodsFor: 'signal-emitting' stamp: 'RL 1/13/2012 14:18'!
searching: aClass in: aPerspective
	Transcript show: aClass name, '@', aPerspective name; cr.
	^ signalHandler emit: #searching with: aClass with: aPerspective! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 11:03'!
selector
	^ selector! !

!PMethodLookup methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 11:03'!
selector: aSelector
	selector := aSelector! !

!PMethodLookup methodsFor: 'signals' stamp: 'RL 12/16/2011 20:03'!
signalHandler
	^ signalHandler! !

Object subclass: #PObject
	instanceVariableNames: 'methodDispatcher'
	classVariableNames: 'InstanceCreatedSignal'
	poolDictionaries: ''
	category: 'Perspectives'!

PObject class
	instanceVariableNames: 'visibleLayer layerToMethodDict'!

PObject class
	instanceVariableNames: 'visibleLayer layerToMethodDict'!

PObject subclass: #PEmployer
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Examples'!

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:52'!
allLayersWithMethods
	^ self layerToMethodDict keys select: [ :layer | (layerToMethodDict at: layer) notEmpty ]! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:17'!
basicAddSelector: aSelector withMethod: compiledMethod
	| ret |
	self = PObject ifTrue: [ ^ super basicAddSelector: aSelector withMethod: compiledMethod ].
	aSelector isEmpty ifTrue: [ ^ super basicAddSelector: aSelector withMethod: compiledMethod ].
	self visibleLayer ifNil: [ ^ self basicLayerAddSelector: aSelector withMethod: compiledMethod ].
	self visibleMethodDict at: aSelector put: compiledMethod.
	super
		basicAddSelector: aSelector
		withMethod: (PMethod new timeStamp: compiledMethod timeStamp; yourself).
	ret := super
		basicAddSelector: (self layerSelector: aSelector)
		withMethod: compiledMethod.
	self updateOrganization.
	^ ret! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 17:12'!
basicLayerAddSelector: aSelector withMethod: compiledMethod
	| layer name res |
	layer := Smalltalk at: (aSelector copyAfter: $_) asSymbol ifAbsent: [ nil ].
	name := (aSelector copyUpTo: $_) asSymbol.
	(self methodDictForLayer: layer) at: name put: compiledMethod.
	res := super basicAddSelector: aSelector withMethod: compiledMethod.
	self updateOrganization.
	^ res! !

!PObject class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 15:58'!
basicNew
	| instance |
	instance := super basicNew.
	self instanceCreated: instance.
	^ instance! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 17:49'!
basicRemoveSelector: aSelector
	| selector ret |
	self = PObject ifTrue: [ ^ super basicRemoveSelector: aSelector ].
	aSelector isEmpty ifTrue: [ ^ super basicRemoveSelector: aSelector ].
	selector := aSelector.
	selector := self layerSelector: selector.
	self visibleMethodDict removeKey: aSelector ifAbsent: [].
	ret := super
		basicRemoveSelector: selector.
	self updateOrganization.
	^ ret! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 14:00'!
clear
	layerToMethodDict := nil! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:23'!
compiledMethodAt: selector for: layer
	^ (self methodDictForLayer: layer) at: selector! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 17:44'!
compiledMethodAt: selector ifAbsent: aBlock
	| c |
	c := self visibleMethodDict at: selector ifAbsent: [ super
		compiledMethodAt: selector
		ifAbsent: [ nil] ].
	^ c ifNil: aBlock! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 13:47'!
definition
	"Answer a String that defines the receiver."

	| aStream path |
	
	self = PObject ifTrue: [ ^ super definition ].
	
	aStream := WriteStream on: (String new: 300).
	superclass == nil
		ifTrue: [aStream nextPutAll: 'ProtoObject']
		ifFalse: [path := ''.
				self environment scopeFor: superclass name from: nil
						envtAndPathIfFound: [:envt :remotePath | path := remotePath].
				aStream nextPutAll: path , superclass name].
	aStream nextPutAll: self kindOfSubclass;
			store: self name.
	aStream cr; tab; nextPutAll: 'in: ';
			nextPutAll: self visibleLayerString.
	aStream cr; tab; nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: ';
			store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: ';
			store: (SystemOrganization categoryOfElement: self name) asString.

	superclass ifNil: [ 
		aStream nextPutAll: '.'; cr.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'. ].

	^ aStream contents! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 14:44'!
inDefaultLayer
	^ visibleLayer == PDefaultLayer! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:52'!
includesSelector: selector for: layer
	^ (self methodDictForLayer: layer) includesKey: selector! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 16:32'!
initialize
	super initialize.
	self visibleLayer: PDefaultLayer! !

!PObject class methodsFor: 'signals' stamp: 'RL 12/29/2011 16:07'!
instanceCreated: anInstance
	self instanceCreatedSignal emitWith: anInstance! !

!PObject class methodsFor: 'signals' stamp: 'RL 12/29/2011 16:06'!
instanceCreatedSignal
	^ InstanceCreatedSignal ifNil: [ InstanceCreatedSignal := PSignal new ]! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 16:37'!
layerSelector: selector
	self visibleLayer ifNil: [ ^ selector ].
	^ (selector asString, '_', self visibleLayer name asString) asSymbol! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 16:21'!
layerToMethodDict
	^ layerToMethodDict ifNil: [
		layerToMethodDict := Dictionary new
	]! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 16:31'!
methodDictForLayer: layer
	layer ifNil: [ ^ self methodDict ].
	^ self layerToMethodDict at: layer ifAbsentPut: [ Dictionary new ]! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 13:14'!
methodDictForLayer: layer put: aDictionary
	^ self layerToMethodDict at: layer put: aDictionary! !

!PObject class methodsFor: 'signals' stamp: 'RL 12/29/2011 16:13'!
onInstanceCreation: aBlock
	^ self instanceCreatedSignal connect: aBlock! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 11:52'!
organization
	self = PObject ifTrue: [ 	^ super organization ].
	organization
		ifNil: [ self organization: (PClassOrganizer defaultList: (self methodDictForLayer: self visibleLayer) keys asSortedCollection) ]
		ifNotNil: [ organization class = PClassOrganizer ifFalse: [ self organization: (PClassOrganizer defaultList: (self methodDictForLayer: self visibleLayer) keys asSortedCollection)] ].
	"self updateOrganization."

	organization ifNotNil: [ organization setSubject: self ].
	^organization! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 15:27'!
removeSelector: selector 
	| priorMethod priorProtocol | 
	priorMethod := self compiledMethodAt: selector ifAbsent: [ nil].
	priorProtocol := priorMethod ifNotNil: [ self whichCategoryIncludesSelector: selector ].

	SystemChangeNotifier uniqueInstance doSilently: [
		self organization removeElement: selector].

	self basicRemoveSelector: selector.

	priorProtocol.
	"SystemChangeNotifier uniqueInstance 
			methodRemoved: priorMethod selector: selector inProtocol: priorProtocol class: self."! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:02'!
selectorsForLayer: layer 
	^ (self methodDictForLayer: layer) keys! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 21:22'!
sourceCodeAt: selector ifAbsent: aBlock
	^ (self visibleMethodDict at: selector ifAbsent: [ ^ super sourceCodeAt: selector ifAbsent: [^ aBlock value]]) getSourceFor: selector in: self! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:51'!
subclass: t in: layer instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat
	| subclass |
	subclass := super
		subclass: t
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat.
	subclass visibleLayer: layer.
	^ subclass! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:53'!
subclass: t instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat
	^ self
		subclass: t
		in: PDefaultLayer
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 22:02'!
updateOrganization
	"| categories |
	categories := self organization elementCategoryDict.
	self organization allMethodSelectors do: [ :selector | self organization removeElement: selector ]."
	"self methodDict: (self methodDictForLayer: layer)."
	"self organization setDefaultList: (self methodDictForLayer: self visibleLayer) keys asSortedCollection."
	"self organization allMethodSelectors do: [ :selector | self organization
		classify: selector
		under: (categories ) ]."
	self organization visibleElements: (self methodDictForLayer: self visibleLayer) keys sort! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 16:31'!
visibleLayer
	^ visibleLayer! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 22:02'!
visibleLayer: layer
	self = PObject ifTrue: [ ^ self ].
	visibleLayer := layer.
	self updateOrganization.! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 13:19'!
visibleLayerString
	^ self visibleLayer name! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 14:54'!
visibleMethodDict
	^ self methodDictForLayer: self visibleLayer! !

!PObject class methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:10'!
wrapMethod: aCompiledMethod
	^ PMethodWrapper for: aCompiledMethod! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 20:55'!
= anObject
	^ anObject class = PObjectInPerspective
		ifTrue: [ anObject = self ]
		ifFalse: [ super = anObject ]
	! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:59'!
@ aLayer
	^ PObjectInPerspective for: self in: aLayer! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 16:10'!
methodDispatcher
	^ methodDispatcher ifNil: [ methodDispatcher := PMethodDispatcher for: self ]! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 11:53'!
proceed
	^ methodDispatcher proceed! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 11:54'!
proceedWith: arg1
	^ methodDispatcher proceedWithArguments: (Array with: arg1)! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 11:54'!
proceedWith: arg1 with: arg2
	^ methodDispatcher proceedWithArguments: (Array with: arg1 with: arg2)! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 11:54'!
proceedWith: arg1 with: arg2 with: arg3
	^ methodDispatcher proceedWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 11:53'!
proceedWithArguments: arguments
	^ methodDispatcher proceedWithArguments: arguments! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:35'!
super
	^ self methodDispatcher superSend! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:35'!
superWith: arg1
	^ self methodDispatcher superSendWithArguments: (Array with: arg1)! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:36'!
superWith: arg1 with: arg2
	^ self methodDispatcher superSendWithArguments: (Array with: arg1 with: arg2)! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:36'!
superWith: arg1 with: arg2 with: arg3
	^ self methodDispatcher superSendWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PObject methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:35'!
superWithArguments: arguments
	^ self methodDispatcher superSendWithArguments: arguments! !

PObject subclass: #PPerson
	instanceVariableNames: 'name address employer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Examples'!

!PPerson methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:28'!
asString
	"handled by a perspective message dispatcher"! !

!PPerson methodsFor: 'META' stamp: 'RL 1/16/2012 13:55'!
asString
	^ self proceed, ' Address: ', address! !

!PPerson methodsFor: 'META' stamp: 'RL 1/16/2012 14:28'!
asString
	^ 'Name: ', name! !

!PPerson methodsFor: 'META' stamp: 'RL 1/16/2012 13:55'!
asString
	^ self proceed, '; [Employer] ', employer! !

PObject subclass: #PerspectiveObject1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/16/2012 16:01'!
callReturnValue
	^ self returnValue! !

!PerspectiveObject1 methodsFor: 'foo' stamp: 'RL 1/13/2012 02:03'!
doSomethingWith: arg1
	"handled by a perspective message dispatcher"! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/13/2012 02:03'!
doSomethingWith: aNumber
	^ self proceedWith: 2*aNumber! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/13/2012 02:01'!
doSomethingWith: aNumber
	^ 2 * aNumber! !

!PerspectiveObject1 methodsFor: 'foo' stamp: 'RL 1/16/2012 16:28'!
method1
	"handled by a perspective message dispatcher"! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/13/2012 02:03'!
method1
	<pragma: #hide>! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/16/2012 16:28'!
method1
	^ true! !

!PerspectiveObject1 methodsFor: 'foo' stamp: 'RL 1/13/2012 02:03'!
newMethod
	"handled by a perspective message dispatcher"! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/13/2012 02:03'!
newMethod
	^ 2! !

!PerspectiveObject1 methodsFor: 'foo' stamp: 'RL 1/13/2012 02:04'!
returnValue
	"handled by a perspective message dispatcher"! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/13/2012 02:04'!
returnValue
	^ 15! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/13/2012 02:01'!
returnValue
	^ 23! !

!PerspectiveObject1 methodsFor: 'foo' stamp: 'RL 1/13/2012 02:04'!
someValue
	"handled by a perspective message dispatcher"! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/13/2012 02:04'!
someValue
	^ self proceed * 2! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/13/2012 02:02'!
someValue
	^ 100! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/12/2012 20:01'!
test
	^ 42! !

!PerspectiveObject1 methodsFor: 'META' stamp: 'RL 1/16/2012 16:03'!
test
	^ 1! !

PerspectiveObject1 subclass: #PerspectiveObject2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!PerspectiveObject2 methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 13:40'!
test
	"handled by a perspective message dispatcher"! !

!PerspectiveObject2 methodsFor: 'META' stamp: 'RL 1/16/2012 13:40'!
test
	Transcript show: 'test 2'; cr.
	^ self super + 1! !

Object subclass: #PObjectInPerspective
	instanceVariableNames: 'object perspective'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

PObjectInPerspective class
	instanceVariableNames: 'instanceCreatedSignal'!

PObjectInPerspective class
	instanceVariableNames: 'instanceCreatedSignal'!

!PObjectInPerspective class methodsFor: 'instance creation' stamp: 'RL 1/12/2012 19:57'!
for: anObject in: aPerspective
	^ super new
		initializeOn: anObject inPerspective: aPerspective! !

!PObjectInPerspective class methodsFor: 'instance creation' stamp: 'RL 1/12/2012 19:57'!
new
	self shouldNotImplement! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
= aPieceOrPObject
	^ aPieceOrPObject = object! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
asString
	^ self printString! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
asStringOrText
	^ self printString! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/13/2012 02:23'!
defaultLabelForInspector
	| stream |
	stream := ReadWriteStream on: ''.
	self printOn: stream.
	^ stream contents asString! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 20:41'!
doesNotUnderstand: aMessage
	^ object methodDispatcher
		sendMessage: aMessage
		from: perspective! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
initializeOn: anObject inPerspective: aPerspective
	object := anObject.
	perspective := aPerspective.
	! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
inspect
	ToolSet inspect: self! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
inspectorClass
	^ Inspector! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
longPrintOn: aStream limitedTo: sizeLimit indent: indent
	"Append to the argument, aStream, the names and values of all of the receiver's instance variables.  Limit is the length limit for each inst var."

	self class allInstVarNames doWithIndex:
		[:title :index |
		indent timesRepeat: [aStream tab].
		aStream nextPutAll: title;
		 nextPut: $:;
		 space;
		 tab;
		 nextPutAll: 
			((self instVarAt: index) printStringLimitedTo: (sizeLimit -3 -title size max: 1));
		 cr]! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
printOn: aStream
	aStream
		nextPutAll: object asString;
		nextPutAll: '@';
		nextPutAll: perspective asString! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
printString
	^ String streamContents: [ :stream | self printOn: stream ].! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
printStringLimitedTo: limit
	"Answer a String whose characters are a description of the receiver.
	If you want to print without a character limit, use fullPrintString."
	| limitedString |
	limitedString := String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...etc...'! !

!PObjectInPerspective methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 19:57'!
yourself
	^ self! !

Object subclass: #PSignal
	instanceVariableNames: 'callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Signals'!

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 1/9/2012 21:17'!
connect: aBlock
	callbacks add: aBlock.
	^ PDisconnector for: [ callbacks remove: aBlock ifAbsent: [] ]
	! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:40'!
disconnectAll
	^ callbacks removeAll! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:34'!
emit
	self emitWithArguments: #()! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1
	self emitWithArguments: (Array with: arg1)! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1 with: arg2
	self emitWithArguments: (Array with: arg1 with: arg2)! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:36'!
emitWith: arg1 with: arg2 with: arg3
	self emitWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:57'!
emitWithArguments: arguments
	callbacks do: [ :callback | 
		callback valueWithArguments: (self resizeArguments: arguments toFit: callback argumentCount)
	]! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 16:38'!
initialize
	super initialize.
	callbacks := Bag new! !

!PSignal methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 14:40'!
resizeArguments: arguments toFit: aSize
	| newArgs |
	newArgs := Array new: aSize.
	1 to: aSize do: [ :i |
		newArgs at: i put: (arguments at: i ifAbsent: [ nil ])
	].
	^ newArgs! !

Object subclass: #PSignalHandler
	instanceVariableNames: 'signals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Signals'!

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:46'!
connect: signalName to: aBlock
	^ ( signals at: signalName ifAbsentPut: [ PSignal new ])
		connect: aBlock! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:47'!
emit: signalName
	 (signals at: signalName ifAbsentPut: [ ^ self ]) emit! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1)! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1 with: arg2
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1 with: arg2)! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/16/2011 20:05'!
emit: signalName with: arg1 with: arg2 with: arg3
	 (signals at: signalName ifAbsentPut: [ ^ self ])
		emitWithArguments: (Array with: arg1 with: arg2 with: arg3)! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:47'!
emit: signalName withArguments: arguments
	 (signals at: signalName ifAbsentPut: [ ^ self ]) emitWithArguments: arguments! !

!PSignalHandler methodsFor: 'as yet unclassified' stamp: 'RL 12/14/2011 13:36'!
initialize
	super initialize.
	signals := Dictionary new! !

Object subclass: #PStep
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

PStep subclass: #PFoundStep
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PFoundStep class methodsFor: 'instance creation' stamp: 'RL 12/29/2011 18:26'!
on: aPObject with: aMethod
	^ self new
		instance: aPObject;
		method: aMethod;
		yourself! !

!PFoundStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:45'!
method
	^ method! !

!PFoundStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:45'!
method: aMethod
	method := aMethod! !

!PFoundStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:52'!
printOn: aStream
	aStream
		nextPutAll: 'found method in: ';
		nextPutAll: method methodClass name
	! !

PStep subclass: #PInstanceCreationStep
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PInstanceCreationStep class methodsFor: 'instance creation' stamp: 'RL 1/7/2012 16:56'!
for: aPObject
	^ self new
		instance: aPObject;
		yourself! !

!PInstanceCreationStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:20'!
isInstanceCreation
	^ true! !

!PInstanceCreationStep methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:04'!
printOn: aStream
	aStream nextPutAll: 'create: '.
	instance value printOn: aStream.! !

PStep subclass: #PLookUpStep
	instanceVariableNames: 'selector perspective'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PLookUpStep class methodsFor: 'instance creation' stamp: 'RL 1/7/2012 16:43'!
on: aPObject with: selector in: perspective
	^ self new
		instance: aPObject;
		selector: selector;
		perspective: perspective;
		yourself! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 16:44'!
perspective
	^ perspective! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 16:44'!
perspective: aPerspective
	perspective := aPerspective! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:05'!
printOn: aStream
	aStream
		nextPutAll: 'looking up: #';
		nextPutAll: selector;
		nextPutAll: '@';
		nextPutAll: perspective name;
		nextPutAll: ' for: '.
	instance printOn: aStream! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:42'!
selector
	^ selector! !

!PLookUpStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:42'!
selector: aSelector
	selector := aSelector! !

PStep subclass: #PSearchingStep
	instanceVariableNames: 'lookupClass perspective'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PSearchingStep class methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:48'!
on: instance for: class in: perspective
	^ self new
		instance: instance;
		lookupClass: class;
		perspective: perspective;
		yourself! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:47'!
lookupClass
	^ lookupClass! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:47'!
lookupClass: class
	lookupClass := class! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:47'!
perspective
	^ perspective! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:46'!
perspective: aPerspective
	perspective := aPerspective! !

!PSearchingStep methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:47'!
printOn: aStream
	aStream
		nextPutAll: 'searching in: ';
		nextPutAll: lookupClass name;
		nextPutAll: '@';
		nextPutAll: perspective name
	! !

!PStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 18:25'!
instance
	^ instance! !

!PStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 18:25'!
instance: aPObject
	instance := aPObject! !

!PStep methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 17:20'!
isInstanceCreation
	^ false! !

Object subclass: #PStepList
	instanceVariableNames: 'steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:17'!
addStep: aPLookupStep
	steps add: aPLookupStep! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:17'!
initialize
	super initialize.
	steps := OrderedCollection new! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:04'!
instances
	^ steps select: [ :step | step isInstanceCreation ] thenCollect: [ :step | step instance ]! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 14:14'!
reset
	steps removeAll! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:19'!
size
	^ steps size! !

!PStepList methodsFor: 'as yet unclassified' stamp: 'RL 12/29/2011 14:18'!
steps
	^ steps! !

Morph subclass: #PArrow
	instanceVariableNames: 'from to arrowBorderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PArrow class methodsFor: 'as yet unclassified' stamp: 'RL 1/10/2012 19:08'!
from: point1 to: point2
	^ self new
		initializeFrom: point1 to: point2;
		yourself! !

!PArrow methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 00:13'!
arrowBoundsAt: endPoint from: priorPoint 
	"Answer a triangle oriented along the line from priorPoint to endPoint."
	| d v angle wingBase arrowSpec length width |
	v := endPoint - priorPoint.
	angle := v degrees.
	d := arrowBorderWidth max: 1.
	arrowSpec := self valueOfProperty: #arrowSpec ifAbsent: [5@4].
	length := arrowSpec x abs.  width := arrowSpec y abs.
	wingBase := endPoint + (Point r: d * length degrees: angle + 180.0).
	arrowSpec x >= 0
		ifTrue: [^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase + (Point r: d * width degrees: angle - 125.0) }]
		ifFalse: ["Negative length means concave base."
				^ {	endPoint.
					wingBase + (Point r: d * width degrees: angle + 125.0).
					wingBase.
					wingBase + (Point r: d * width degrees: angle - 125.0) }]! !

!PArrow methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 00:16'!
drawArrowOn: canvas
	canvas
		line: from to: to width: 2 color: Color black;
		drawPolygon: (self arrowBoundsAt: to from: from)
		color: Color white borderWidth: arrowBorderWidth borderColor: Color black! !

!PArrow methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 00:18'!
drawOn: aCanvas
	aCanvas
		translateBy: self owner position
		during: [ :canvas | self drawArrowOn: canvas ]! !

!PArrow methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 00:18'!
initialize
	super initialize.
	"self color: (Color yellow alpha: 0.2)."
	arrowBorderWidth := 2! !

!PArrow methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:39'!
initializeFrom: aPoint to: anotherPoint
	from := aPoint.
	to := anotherPoint.
	self bounds: (from rect: to).! !

Morph subclass: #PInstanceMorph
	instanceVariableNames: 'instance classMorphs arrowMorphs layerMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PInstanceMorph class methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:06'!
for: instance
	^ self new
		instance: instance;
		yourself! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 01:09'!
addArrowMorphs
	classMorphs overlappingPairsDo: [ :m1 :m2 | | arrow |
		arrow := PArrow from: m2 bounds topCenter to: m1 bounds bottomCenter.
		self addMorph: arrow.
		arrowMorphs add: arrow
	]! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 16:43'!
addClassMorphs
	| y w padding |
	classMorphs removeAll.
	padding := 10.
	y := padding.
	w := 0.
	instance classHierarchy reverseDo: [ :class | | m |
		m := PClassMorph for: class.
		m position: padding@y.
		y := y+m height+50.
		w := w max: m width.
		self addMorph: m.
		classMorphs add: m.
	].
	classMorphs do: [ :m | m width: w ].! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:45'!
adjust
	self
		removeAllMorphs;
		addClassMorphs;
		addArrowMorphs;
		bounds: self boundingBoxOfSubmorphs
	! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 13:00'!
initialize
	super initialize.
	classMorphs := OrderedCollection new.
	arrowMorphs := OrderedCollection new.
	layerMorphs := OrderedCollection new.
	self color: Color lightGray.! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:06'!
instance
	^ instance! !

!PInstanceMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 17:07'!
instance: anInstance
	instance := anInstance.
	self adjust! !

BorderedMorph subclass: #PClassMorph
	instanceVariableNames: 'classToVisualize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PClassMorph class methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:00'!
for: aClass
	^ self new
		classToVisualize: aClass;
		adjust;
		yourself! !

!PClassMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:21'!
add: layer to: collection
	(collection includes: layer)
		ifTrue: [ ^ self ].
	layer parentLayer
		ifNotNil: [ :parent | self add: parent to: collection ].
	collection add: layer! !

!PClassMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:56'!
addArrowsFor: layerToMorph to: morph
	| top o i |
	layerToMorph isEmpty ifTrue: [ ^ self ].
	top := layerToMorph anyOne top.
	o := ((layerToMorph collect: [ :m | m height ]) min) / layerToMorph size.
	i := 1.
	layerToMorph keysAndValuesDo: [ :layer :layerMorph |
		layer parentLayer ifNotNil: [ :parent | | arrow y |
			y := top + (o*i) rounded.
			arrow := PArrow
				from: layerMorph bounds left @ y
				to: (layerToMorph at: parent) bounds right @ y.
			i := i + 1.
			morph addMorph: arrow.
		]
	]! !

!PClassMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:27'!
adjust
	| classMorph layersMorph separator |
	self removeAllMorphs.
	self
		layoutPolicy: TableLayout new;
		cellPositioning: #center;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	classMorph := self classMorph.
	separator := Morph new height: 2; hResizing: #spaceFill; color: Color black; yourself.
	layersMorph := self layersMorph.
	self
		addMorph: layersMorph;
		addMorph: separator;
		addMorph: classMorph;
		bounds: (self boundingBoxOfSubmorphs).! !

!PClassMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 12:43'!
classMorph
	| classMorph textMorph |
	textMorph := TextMorph new.
	textMorph
		contents: classToVisualize name.
	classMorph := Morph new.
	classMorph
		color: Color transparent;
		bounds: (textMorph bounds expandBy: 5);
		layoutPolicy: TableLayout new;
		layoutInset: 5.
	classMorph addMorph: textMorph.
	^ classMorph! !

!PClassMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 14:27'!
classToVisualize
	^ classToVisualize! !

!PClassMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:01'!
classToVisualize: aClass
	classToVisualize := aClass! !

!PClassMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 00:54'!
initialize
	super initialize.
	"textMorph backgroundColor: Color red."
	self color: Color white.! !

!PClassMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:20'!
layers
	| collection |
	collection := OrderedCollection new.
	classToVisualize allLayersWithMethods do: [ :layer | self add: layer to: collection ].
	^ collection! !

!PClassMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:52'!
layersMorph
	| layersMorph layerToMorph x |
	layerToMorph := Dictionary new.
	layersMorph := Morph new.
	x := 10.
	layersMorph color: Color transparent.
	self layers do: [ :layer | | m |
		m := PLayerMorph for: classToVisualize in: layer.
		m position: x@10.
		x := x + m width + 30.
		layersMorph addMorph: m.
		layerToMorph at: layer put: m.
	].
	layersMorph hasSubmorphs ifTrue: [
		layersMorph width: (layersMorph submorphs inject: 0 into: [ :total :s | total + s width + 30 ]).
		layersMorph height: (layersMorph submorphs collect: [ :s | s height ]) max + 20.
	] ifFalse: [ layersMorph extent: 0@0 ].
	self addArrowsFor: layerToMorph to: layersMorph.
	^ layersMorph! !

BorderedMorph subclass: #PLayerMorph
	instanceVariableNames: 'classToVisualize layer methodsMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PLayerMorph class methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:00'!
for: aClass in: aLayer
	^ self new
		classToVisualize: aClass;
		layer: aLayer;
		adjust;
		yourself! !

!PLayerMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:02'!
adjust
	| layerMorph methodMorph separator |
	self removeAllMorphs.
	self
		layoutPolicy: TableLayout new;
		cellPositioning: #center;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	layerMorph := self layerMorph.
	separator := Morph new height: 2; hResizing: #spaceFill; color: Color black; yourself.
	methodMorph := self methodMorph.
	self
		addMorph: methodMorph;
		addMorph: separator;
		addMorph: layerMorph;
		bounds: (self boundingBoxOfSubmorphs)! !

!PLayerMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:45'!
classToVisualize
	^ classToVisualize! !

!PLayerMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:00'!
classToVisualize: aClass
	classToVisualize := aClass! !

!PLayerMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:45'!
initialize
	super initialize.
	"textMorph backgroundColor: Color red."
	self color: Color white.! !

!PLayerMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:34'!
isHidden: aSelector
	| method |
	method := (classToVisualize methodDictForLayer: layer) at: aSelector ifAbsent: [^self].
	^ method
		ifNil: [ false ]
		ifNotNil: [
			method pragmas
				anySatisfy: [ :pragma | pragma arguments
					anySatisfy: [ :arg | arg = #hide ] ] ]! !

!PLayerMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:56'!
layer
	^ layer! !

!PLayerMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:00'!
layer: aLayer
	layer := aLayer! !

!PLayerMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:59'!
layerMorph
	| layerMorph textMorph |
	textMorph := TextMorph new.
	textMorph
		contents: self layer name.
	layerMorph := Morph new.
	layerMorph
		color: Color transparent;
		bounds: (textMorph bounds expandBy: 5);
		layoutPolicy: TableLayout new;
		layoutInset: 5.
	layerMorph addMorph: textMorph.
	^ layerMorph! !

!PLayerMorph methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:38'!
methodMorph
	| methodMorph |
	methodMorph := Morph new.
	methodMorph
		color: Color transparent;
		layoutPolicy: TableLayout new;
		listDirection: #bottomToTop;
		layoutInset: 5;
		cellPositioning: #topLeft;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	(classToVisualize selectorsForLayer: layer) sort do: [ :selector | | m |
		m := TextMorph new.
		m contents: selector asString.
		(self isHidden: selector)
			ifTrue: [ m addMorph: (Morph new color: Color black; height: 1; width: m width; top: (m top+(m height / 2) rounded); yourself) ].
		methodMorph addMorph: m
	].
	methodMorph hasSubmorphs ifTrue: [
		methodMorph width: (methodMorph submorphs collect: [ :s | s width ]) max.
		methodMorph height: (methodMorph submorphs inject: 0 into: [ :total :s | total + s height  ]).
	] ifFalse: [ methodMorph extent: 0@0 ].
	^ methodMorph! !

TextMorphForEditView subclass: #PTextMorphForEditView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 14:03'!
editorClass
	^ PEditor! !

SmalltalkEditor subclass: #PEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Visualization'!

!PEditor class methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 14:09'!
cmdActions
	^ SmalltalkEditor cmdActions! !

!PEditor class methodsFor: 'as yet unclassified' stamp: 'RL 1/7/2012 14:09'!
shiftCmdActions
	^ SmalltalkEditor shiftCmdActions! !

!PEditor methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 13:50'!
afterEvaluate
	(model respondsTo: #afterEvaluate)
		ifTrue: [ model perform: #afterEvaluate ]! !

!PEditor methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 13:50'!
beforeEvaluate
	(model respondsTo: #beforeEvaluate)
		ifTrue: [ model perform: #beforeEvaluate ]! !

!PEditor methodsFor: 'as yet unclassified' stamp: 'RL 1/11/2012 13:51'!
evaluateSelection
	| result |
	self beforeEvaluate.
	result := super evaluateSelection.
	self afterEvaluate.
	^ result! !

ClassOrganizer subclass: #PClassOrganizer
	instanceVariableNames: 'visibleElements categoryDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives'!

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 23:40'!
allMethodSelectors
	^ visibleElements ifNil: [ Array new ]! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:20'!
categories
	categoryArray isNil ifTrue: [^ nil].
	(categoryArray size = 1 
		and: [categoryArray first = Default & (visibleElements size = 0)])
		ifTrue: [^Array with: NullCategory].
	^categoryArray! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:32'!
categoryDict
	^ categoryDict ifNil: [ categoryDict := Dictionary new ]! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 21:48'!
categoryOfElement: element 
	| category |
	(element includes: $_) ifTrue: [ ^ 'META' ].
	category := super categoryOfElement: element.
	category ifNil: [ category := self class default ].
	^ category! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:33'!
classify: element under: heading suppressIfDefault: aBoolean
	| e | 
	e := (element includes: $_) ifFalse: [ element ] ifTrue: [ element copyUpTo: $_ ].
	^ self categoryDict at: e put: heading! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 23:38'!
elementCategoryDict
	^ super elementCategoryDict
		ifNotNil: [ :dict | dict associationsSelect: [ :assoc | self visibleElementsIncludes: assoc key ] ]! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 14:27'!
listAtCategoryNumber: anInteger 
	^ self visibleElements select: [ :element | (self numberOfCategoryOfElement: element) = anInteger ]! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 22:30'!
removeCategory: cat 
	| index lastStop |
	index := categoryArray indexOf: cat ifAbsent: [^self].
	lastStop := 
		index = 1
			ifTrue: [0]
			ifFalse: [categoryStops at: index - 1].
	(categoryStops at: index) - lastStop > 0 
		ifTrue: [^self ].
	categoryArray := categoryArray copyReplaceFrom: index to: index with: Array new.
	categoryStops := categoryStops copyReplaceFrom: index to: index with: Array new.
	categoryArray size = 0
		ifTrue:
			[categoryArray := Array with: Default.
			categoryStops := Array with: 0]
! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 22:03'!
visibleElements
	^visibleElements! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 22:24'!
visibleElements: elements
	visibleElements := elements asArray! !

!PClassOrganizer methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 23:38'!
visibleElementsIncludes: element
	^ visibleElements
		ifNil: [ false ]
		ifNotNil: [ :v | v includes: element ]! !

TestCase subclass: #TestPerspectives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Perspectives-Tests'!

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:03'!
testDirectPerspectiveCall
	| object |
	object := PerspectiveObject1 new.
	self assert: [ object test = 42 ].
	self assert: [ (object @ TestLayer) test = 1 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 21:01'!
testDoesNotUnderstand
	| object |
	object := PerspectiveObject1 new.
	self should: [ object foo ] raise: MessageNotUnderstood.
	self should: [ (object @ nil) foo ] raise: MessageNotUnderstood.
	self should: [ (object @ TestLayer) foo ] raise: MessageNotUnderstood.! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:27'!
testHiddenMethod
	| object |
	object := PerspectiveObject1 new.
	(object @ TestLayer) method1.
	self should: [ (object @ TestChildLayer) method1 ] raise: MessageNotUnderstood.! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 21:01'!
testIdentityInvariant
	| object |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) = (object @ TestChildLayer) ].
	self assert: [ (object @ TestLayer) = object ].
	self assert: [ object = (object @ TestLayer) ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 16:02'!
testIndirectPerspectiveCall
	| object |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) callReturnValue = 23 ].
	self assert: [ (object @ TestChildLayer) callReturnValue = 15 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 21:01'!
testLayerSwitching
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestChildLayer @ TestLayer) returnValue = 23 ].
	self assert: [ (object @ TestLayer @ TestChildLayer) returnValue = 15 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 1/16/2012 15:59'!
testParentLayer
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) returnValue = 23 ].
	self assert: [ (object @ TestChildLayer) returnValue = 15 ].! !

!TestPerspectives methodsFor: 'as yet unclassified' stamp: 'RL 1/12/2012 21:01'!
testProceed
	| object  |
	object := PerspectiveObject1 new.
	self assert: [ (object @ TestLayer) someValue = 100 ].
	self assert: [ (object @ TestChildLayer) someValue = 200 ].
	
	self assert: [ ((object @ TestLayer) doSomethingWith: 5) = 10 ].
	self assert: [ ((object @ TestChildLayer) doSomethingWith: 5) = 20 ]! !
PObject initialize!
